<?php

if (!function_exists('msglog')) {
    function msglog($msg,$log=''){
        if($log==''){
            $log = FCPATH.'logs/'.date('Y-m-d').'.log';
        }
        error_log("\n".date('Y-m-d H:i:s')." ".$msg,3,$log);
    }
}

if (!function_exists('randomPassword')) {
    function randomPassword($length){
        $alphabet = "abcdefghijkmnopqrstuwxyz0123456789ABCDEFGHJKLMNOPQRSTUWXYZ";
        $pass = array(); //remember to declare $pass as an array
        $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
        for ($i = 0; $i < $length; $i++) {
            $n = rand(0, $alphaLength);
            $pass[] = $alphabet[$n];
        }
        return implode($pass); //turn the array into a string
    }
}

function multi_thread_exec_headers($nodes,$RESP_TIMEOUT=30,$GETPARTYROLEID=true,$CUSTOM_REQUEST="")
{
    global $api_md5;
    $CURLOPT_HTTPHEADERS=array();
    $CURLOPT_HTTPHEADERS[0] ='key:'.KEY;
    if(isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST']!='')
    $CURLOPT_HTTPHEADERS[1]='user:'.MD_HOST;
    else if(isset($api_md5) && $api_md5!='')
    $CURLOPT_HTTPHEADERS[1]='user:'.$api_md5;
    return multi_thread_exec($nodes,$CURLOPT_HTTPHEADERS,$RESP_TIMEOUT,$GETPARTYROLEID,$CUSTOM_REQUEST);
}

function multi_thread_exec_headers_md5($nodes,$md5,$RESP_TIMEOUT=30,$GETPARTYROLEID=true,$CUSTOM_REQUEST="")
{
    $CURLOPT_HTTPHEADERS=array();
    $CURLOPT_HTTPHEADERS[0] ='key:'.KEY;
    $CURLOPT_HTTPHEADERS[1]='user:'.$md5;
    return multi_thread_exec($nodes,$CURLOPT_HTTPHEADERS,$RESP_TIMEOUT,$GETPARTYROLEID,$CUSTOM_REQUEST);
}

function multi_thread_exec($nodes,$CURLOPT_HTTPHEADERS="",$RESP_TIMEOUT=30,$GETPARTYROLEID=true,$CUSTOM_REQUEST="",$auth="")
{
    global $CODEPATH,$ORG_DOMAIN, $ANALYTICSLOGPATH, $info,$debug_info,$response_code,$external_urls;
    $node_count = count($nodes);
    //$RESP_TIMEOUT = $RESP_TIMEOUT*10; // default 5 secs timeout

    $curl_arr = array();
    $master = curl_multi_init();
    $tmp_str_cookies    = "";

    $tmp_arr_httpheader = array("Connection: Close");
    if (!empty($CURLOPT_HTTPHEADERS))
    {
        $tmp_arr_httpheader = array_merge($CURLOPT_HTTPHEADERS,$tmp_arr_httpheader);
    }

    $options = array(
        CURLOPT_RETURNTRANSFER => true,         // return web page
        CURLOPT_HEADER         => false,        // don't return headers
        CURLOPT_FOLLOWLOCATION => true,         // follow redirects
        CURLOPT_ENCODING       => "",           // handle all encodings
        CURLOPT_AUTOREFERER    => true,         // set referer on redirect
        CURLOPT_CONNECTTIMEOUT_MS => 200,          // timeout on connect
        //       CURLOPT_TIMEOUT_MS        => $RESP_TIMEOUT,          // timeout on response
        CURLOPT_USERPWD        => trim($auth),
        CURLOPT_MAXREDIRS      => 10,           // stop after 10 redirects
        CURLOPT_SSL_VERIFYHOST => 0,            // don't verify ssl
        CURLOPT_SSL_VERIFYPEER => false,        //
        CURL_HTTP_VERSION_1_1  => 1,
        CURLOPT_NOSIGNAL        => true,
        CURLOPT_ENCODING        => 'gzip,deflate',
        CURLOPT_HTTPHEADER      =>$tmp_arr_httpheader,
        CURLOPT_REFERER         => "http://staging.hirenexus.com"
    );

    if($tmp_str_cookies !="")
    $options[CURLOPT_COOKIE] = $tmp_str_cookies;


    if($CUSTOM_REQUEST !="")
    $options[CURLOPT_CUSTOMREQUEST] = $CUSTOM_REQUEST;

    for($i = 0; $i < $node_count; $i++)
    {
        $url                = (is_array($nodes[$i]) && !empty($nodes[$i]['url'])) ? $nodes[$i]['url'] : $nodes[$i];
        $resp_timeout =  (is_array($nodes) && !empty($nodes[$i]['resp_timeout'])) ? $nodes[$i]['resp_timeout'] : $RESP_TIMEOUT; // default 5 secs timeout
        $curl_arr[$i]       = curl_init();

        curl_setopt($curl_arr[$i], CURLOPT_URL, $url);
        //      curl_setopt($curl_arr[$i], CURLOPT_TIMEOUT, $resp_timeout);

        if (is_array($nodes[$i]))
        {
            if (!empty($nodes[$i]['post'])) {
                if (is_array($nodes[$i]['post']))
                {
                    $o="";
                    foreach ($nodes[$i]['post'] as $k=>$v)
                    {
                        $o.= "$k=".$v."&";
                    }
                    $post_data=substr($o,0,-1);
                }
                else
                {
                    $post_data = $nodes[$i]['post'];

                }
                curl_setopt($curl_arr[$i], CURLOPT_POST,1);
                curl_setopt($curl_arr[$i], CURLOPT_POSTFIELDS,$post_data);
            }
            elseif (!empty($nodes[$i]['put']))
            {
                if (is_array($nodes[$i]['put']))
                {
                    $o="";
                    foreach ($nodes[$i]['put'] as $k=>$v)
                    {
                        $o.= "$k=".$v."&";
                    }
                    $post_data=substr($o,0,-1);
                }
                else
                {
                    $post_data = $nodes[$i]['put'];

                }
                curl_setopt($curl_arr[$i], CURLOPT_CUSTOMREQUEST,'PUT');
                curl_setopt($curl_arr[$i], CURLOPT_POSTFIELDS,$post_data);
            }
        }
        curl_setopt($curl_arr[$i], CURLOPT_TIMEOUT, $resp_timeout);
        curl_setopt_array($curl_arr[$i],$options);
        //      curl_setopt($curl_arr[$i],"CURLOPT_HTTPHEADER",array("Connection: Close\r\n"));
        curl_multi_add_handle($master, $curl_arr[$i]);

    } // EO for loop

    #   $time_start = microtime(true);
    do {
        curl_multi_exec($master,$running);
        //error_log($running." time check".time());
        usleep(5000);
    } while($running > 0);

    //$info = "\n\n";
    //$time_start = microtime(true);
    for($i = 0; $i < $node_count; $i++)
    {
        $results[$i] = curl_multi_getcontent  ( $curl_arr[$i]  );

        $tmp_arr = (curl_getinfo($curl_arr[$i]));
        //$bytes     = curl_getinfo($curl_arr[$i], CURLINFO_CONTENT_LENGTH_DOWNLOAD);
        $gzbytes   = strlen(gzcompress($results[$i], 9));//compress level : 9 for max compress
        $strbytes   = strlen($results[$i]);

        if ($tmp_arr['http_code'] == 404 || $tmp_arr['http_code'] == 500 || $tmp_arr['http_code'] == 503)
        {
            $results[$i] = "";
        }

        curl_multi_remove_handle($master, $curl_arr[$i]);
        curl_close($curl_arr[$i]);

        $info .= "\t".$tmp_arr['total_time']; // seconds

        $debug_info1 = $nodes[$i]['url']."\t".$tmp_arr['total_time']."\t".byte_convert($strbytes)."\t".$tmp_arr['http_code']."\t 0 \n";
        $response_code=$tmp_arr['http_code'];
        /*
        echo "<br /> ===== <br />".$log_file_path;

        // if($log_file_path!='')

        {msglog("debug_info ".$debug_info,$log_file_path); $log_file_path=''; }
        echo "<br /> ===== <br />123";
        // error_log("debug_info ".$debug_info,3,$log_file_path);
        */
        if(!empty($external_urls))
        foreach($external_urls as $url1){
            if(isset($nodes[$i]['url']) && strpos($nodes[$i]['url'],$url1)!==FALSE)
            {
                $log_file_path1 = FCPATH.'api_logs/reattempt_rto_'.date('Y-m-d').'.log';
                msglog("debug_info ".$debug_info1,$log_file_path1);

            }
        }
    }
    curl_multi_close($master);

    // runtime logging for performance testing
    $info .= "\n";
    //$datetime = date("Ymd");
    //$filename = $LOGPATH."/".$datetime."response_log";
    //$fp = fopen($filename, "a");
    //if($fp)
    //{
    //fwrite($fp, $info);
    //fclose($fp);
    //}
    //unset($info);
    return $results;
}

function byte_convert($bytes)
{
    $symbol = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');

    $exp = 0;
    $converted_value = 0;
    if( $bytes > 0 )
    {
        $exp = floor( log($bytes)/log(1024) );
        $converted_value = ( $bytes/pow(1024,floor($exp)) );
    }

    return sprintf( '%.2f '.$symbol[$exp], $converted_value );
}

function clean_url_string($str)
{
    $str = trim($str);
    if($str=="" || empty($str))
    {
        return strtolower($str);
    }
    else
    {
        $str = preg_replace("/[^a-zA-Z0-9.\s]/","",$str);
        $str = str_replace(" ","-",trim($str));
        return strtolower($str);
    }

}//EO function clean_url_string($str)


function handle_smartquotes(&$input)
{
    $text = str_replace(array("\xe2\x80\x98", "\xe2\x80\x99", "\xe2\x80\x9c", "\xe2\x80\x9d", "\xe2\x80\x93", "\xe2\x80\x94", "\xe2\x80\xa6"),array("'", "'", '"', '"', '-', '--', '...'),$input);

    return $text;

}

function unclean_url_string($str){

    if($str=="" || empty($str)){
        return $str;
    }
    else{
        $str = preg_replace("/[^a-zA-Z0-9.-\s]/","",$str);
        $str = str_replace("-"," ",$str);
        return $str;
    }

}
function clean_string($str){

    if($str=="" || empty($str)){
        return $str;
    }
    else{
        $str = preg_replace("/[^a-zA-Z0-9.-\s]/","",$str);
        return $str;
    }

}

?>
