<?php
Class Manage_product_model extends CI_Model {

	function __construct()
	{
		parent::__construct();
	}

	function get_product_list($page_no,$per_page)
	{
		$sql = "select *,if(is_active='1','Active','Inactive') as status from product_master where is_deleted='0' limit $page_no,$per_page";
		$query = $this->db->query($sql);
		return $query->result_array();
	}

	function get_product_banners($product_id)
	{
		$sql = "select * from prod_image_mapping where is_deleted='0' and prod_id='".$product_id."' order by banner_no asc";
		$query = $this->db->query($sql);
		return $query->result_array();
	}

	function get_product($product_id)
	{
		$sql = "select *,if(is_active='1','Active','Inactive') as status from product_master where is_deleted='0' and id='$product_id'";
		$query = $this->db->query($sql);
		return $query->row_array();
	}

	function product_delete($product_id)
	{
		$cur_date = date('Y-m-d H:i:s');
		$loginid = $this->loginid;
		$data = array('is_deleted'=>'1','is_active'=>'0','updated_date'=>$cur_date,'updated_by'=>$loginid);
		$this->db->where('id',$product_id);
		$this->db->update('product_master',$data);
		if($this->db->affected_rows()>0)
        {
            $this->insert_record($product_id,'delete');
            return TRUE;
        }
		else
			return FALSE;
	}

    function insert_product()
    {
        $loginid = $this->loginid;
		$name = $this->input->post('name',TRUE);
		$title = $this->input->post('title',TRUE);
		$description = $this->input->post('description',TRUE);
		$yt_link = $this->input->post('yt_link',TRUE);
		$cat_id = $this->input->post('cat_id',TRUE);
		$ecom_link = $this->input->post('ecom_link',TRUE);
// echo "<pre>";
// print_r($_FILES);
// print_r($_REQUEST);exit;
		$insert_data = array(
            'name'=>$name,
            'title'=>$title,
            'description'=>$description,
            'yt_link'=>$yt_link,
            'ecom_link'=>$ecom_link,
            'cat_id'=>$cat_id,
            'created_by'=>$loginid,
        );

		$query = $this->db->insert('product_master',$insert_data);
		if($this->db->affected_rows()>0)
        {
            $product_id = $this->db->insert_id();
            $animation_path = $this->input->post('animation_path');
            if(isset($_FILES['animation']) && !empty($_FILES['animation']['name']))
            {
                $animation_file = explode('.',$_FILES['animation']['name']);
                $animation_file = end($animation_file);
                $a_fileName = $product_id.'.'.$animation_file;
                $animation_path = "assets/animation/".$a_fileName;
                $a_temp_name = $_FILES['animation']['tmp_name'];
                move_uploaded_file($_FILES['animation']['tmp_name'], $animation_path);
            }

            $product_path = $this->input->post('product_path');
            if(isset($_FILES['product_img']) && !empty($_FILES['product_img']['name']))
            {
                $animation_file = explode('.',$_FILES['product_img']['name']);
                $animation_file = end($animation_file);
                $a_fileName = $product_id.'.'.$animation_file;
                $product_path = "assets/product/".$a_fileName;
                $a_temp_name = $_FILES['product_img']['tmp_name'];
                move_uploaded_file($_FILES['product_img']['tmp_name'], $product_path);
            }

            $buy_path = $this->input->post('buy_path');
            if(isset($_FILES['buy_img']) && !empty($_FILES['buy_img']['name']))
            {
                $animation_file = explode('.',$_FILES['buy_img']['name']);
                $animation_file = end($animation_file);
                $a_fileName = $product_id.'.'.$animation_file;
                $buy_path = "assets/buy/".$a_fileName;
                $a_temp_name = $_FILES['buy_img']['tmp_name'];
                move_uploaded_file($_FILES['buy_img']['tmp_name'], $buy_path);
            }

            $data = array('animation_img'=>$animation_path,'buy_img'=>$buy_path,'img_link'=>$product_path);
            $this->db->where('id',$product_id);
            $this->db->update('product_master',$data);

            $this->insert_record($product_id,'insert');
            return TRUE;
        }
		else
			return FALSE;
    }

    function img_insert($data = array()){
        // for ($i=0; $i < count($data); $i++) {
        //     $result = $this->db->insert('prod_image_mapping',$data[$i]);
        //     $insert_id = $this->db->insert_id();
        //     $this->insert_record($insert_id,'insert','1');
        // }
        // return true;

        $result = $this->db->insert_batch('prod_image_mapping',$data);
        if($result)
        {
            $insert_id = isset($data[0]['prod_id'])?$data[0]['prod_id']:'';
            if(!empty($insert_id))
            {
                $this->insert_record($insert_id,'update');
            }
            return true;
        }
        else
            return false;
    }

    function remove_product($id){
        $insert_id = $this->db->where('id',$id)->select('prod_id')->get('prod_image_mapping')->row()->prod_id;
        $result = $this->db->query("UPDATE prod_image_mapping SET is_deleted='1' where id='".$id."'");
        if($result)
        {
            $this->insert_record($insert_id,'update');
            return true;
        }
        else
            return false;
    }

    function update_order($id_array){
        $login_id = $this->loginid;
        $count = 1;
        foreach ($id_array as $id){
            $update = $this->db->query("UPDATE prod_image_mapping SET banner_no = $count, updated_date = NOW(), updated_by='".$login_id."' WHERE id = $id");
            $count ++;
        }
        $id1 = isset($id_array[0])?$id_array[0]:0;
        $insert_id = $this->db->where('id',$id1)->select('prod_id')->get('prod_image_mapping')->row()->prod_id;
        if(!empty($insert_id))
        {
            $this->insert_record($insert_id,'update','0');
        }
        return TRUE;
    }

    function update_product($product_id)
    {
        $this->load->library('upload');
        $loginid = $this->loginid;
    	$cur_date = date('Y-m-d H:i:s');
    	$name = $this->input->post('name',TRUE);
        $title = $this->input->post('title',TRUE);
		$description = $this->input->post('description',TRUE);
		$yt_link = $this->input->post('yt_link',TRUE);
		$ecom_link = $this->input->post('ecom_link',TRUE);
		$cat_id = $this->input->post('cat_id',TRUE);

        $animation_path = $this->input->post('animation_path');
        if(isset($_FILES['animation']) && !empty($_FILES['animation']['name']))
        {
            $animation_file = explode('.',$_FILES['animation']['name']);
            $animation_file = end($animation_file);
            $a_fileName = $product_id.'.'.$animation_file;
            $animation_path = "assets/animation/".$a_fileName;
            $a_temp_name = $_FILES['animation']['tmp_name'];
            move_uploaded_file($_FILES['animation']['tmp_name'], $animation_path);
        }

        $product_path = $this->input->post('product_path');
        if(isset($_FILES['product_img']) && !empty($_FILES['product_img']['name']))
        {
            $animation_file = explode('.',$_FILES['product_img']['name']);
            $animation_file = end($animation_file);
            $a_fileName = $product_id.'.'.$animation_file;
            $product_path = "assets/product/".$a_fileName;
            $a_temp_name = $_FILES['product_img']['tmp_name'];
            move_uploaded_file($_FILES['product_img']['tmp_name'], $product_path);
        }

        $buy_path = $this->input->post('buy_path');
        if(isset($_FILES['buy_img']) && !empty($_FILES['buy_img']['name']))
        {
            $animation_file = explode('.',$_FILES['buy_img']['name']);
            $animation_file = end($animation_file);
            $a_fileName = $product_id.'.'.$animation_file;
            $buy_path = "assets/buy/".$a_fileName;
            $a_temp_name = $_FILES['buy_img']['tmp_name'];
            move_uploaded_file($_FILES['buy_img']['tmp_name'], $buy_path);
        }

		$data = array(
            'name'=>$name,
            'title'=>$title,
            'description'=>$description,
            'yt_link'=>$yt_link,
            'img_link'=>$product_path,
            'buy_img'=>$buy_path,
            'cat_id'=>$cat_id,
            'animation_img'=>$animation_path,
            'ecom_link'=>$ecom_link,
            'updated_by'=>$loginid,
            'updated_date'=>$cur_date
        );

		$this->db->where('id',$product_id);
		$query = $this->db->update('product_master',$data);
		if($this->db->affected_rows()>0)
        {
            $this->insert_record($product_id,'update');
            return TRUE;
        }
		else
			return FALSE;
    }

    function insert_record($prod_id,$status,$type=0)
    {
        $insData = array('prod_id'=>$prod_id,'status'=>$status,'type'=>$type);
        $this->db->insert('record_change_detail',$insData);
    }

}
